# Generated by Django 3.2.16 on 2022-11-15 16:10

import django.db.models.deletion
from django.db import migrations, models

import achievements.models.extrafield


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("members", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Achieved",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "achieved_on",
                    models.DateField(
                        auto_now=True,
                        help_text="date the associated achievement was achieved by the associated person",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Medal",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        help_text="geef de achievement een naam", max_length=200
                    ),
                ),
                (
                    "abbrev",
                    achievements.models.extrafield.LowerCharField(
                        help_text="een unieke!! voor user leesbare afkorting, die wordt gebruikt in urls",
                        max_length=20,
                        unique=True,
                    ),
                ),
                (
                    "description",
                    models.CharField(
                        default="",
                        help_text="een omschrijving van de achievement",
                        max_length=200,
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            (
                                "bsgp1234",
                                "BronzeSilverGoldPlatinum, short multiplier(1,2,3,4)",
                            ),
                            (
                                "bsgp125A",
                                "BronzeSilverGoldPlatinum, long multiplier(1,2,5,10)",
                            ),
                        ],
                        default="bsgp1234",
                        help_text="het type medal. bepaalt hoe de verschillende ranks tot elkaar verhouden",
                        max_length=8,
                    ),
                ),
                (
                    "value",
                    models.IntegerField(
                        blank=True,
                        help_text="de basisfactor voor de medal. bepaalt de requirement voor brons.",
                        null=True,
                    ),
                ),
                (
                    "continuous_checks",
                    models.BooleanField(
                        default=False,
                        help_text="bepaalt of de medal automatisch geupdated wordt. Zet deze op False als je de medal deactiveert.",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Received",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "received_on",
                    models.DateField(
                        auto_now=True,
                        help_text="de datum waarop de medaille verdiend is",
                    ),
                ),
                (
                    "rank",
                    models.IntegerField(
                        choices=[
                            (0, "Air"),
                            (1, "Bronze"),
                            (2, "Silver"),
                            (3, "Gold"),
                            (4, "Platinum"),
                        ],
                        default=0,
                        help_text="de soort van de medaille.",
                    ),
                ),
                (
                    "count",
                    models.IntegerField(
                        default=0,
                        help_text="aantal van datgene waarvoor de achievement is",
                    ),
                ),
                (
                    "medal",
                    models.ForeignKey(
                        default=1,
                        help_text="de medaille die verdiend is",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="achievements.medal",
                    ),
                ),
                (
                    "person",
                    models.ForeignKey(
                        help_text="de persoon die een medaille verdiend heeft.",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="members.person",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="medal",
            name="receivers",
            field=models.ManyToManyField(
                help_text="de mensen die een rank hebben in deze medal.",
                through="achievements.Received",
                to="members.Person",
            ),
        ),
        migrations.CreateModel(
            name="Achievement",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        help_text="de naam van de achievement", max_length=200
                    ),
                ),
                (
                    "abbrev",
                    achievements.models.extrafield.LowerCharField(
                        help_text="een unieke!! voor user leesbare afkorting, die wordt gebruikt in urls",
                        max_length=20,
                        unique=True,
                    ),
                ),
                (
                    "description",
                    models.CharField(
                        default="",
                        help_text="een omschrijving van de achievement",
                        max_length=200,
                    ),
                ),
                (
                    "hidden",
                    models.BooleanField(
                        default=True,
                        help_text="zegt of de achievement verborgen is voor mensen die hem niet hebben",
                    ),
                ),
                (
                    "continuous_checks",
                    models.BooleanField(
                        default=False,
                        help_text="zegt of automatisch en herhaaldelijk gecontroleerd wordt of mensen deze achievement moeten krijgen",
                    ),
                ),
                (
                    "achievers",
                    models.ManyToManyField(
                        help_text="de mensen die deze achievement hebben gehaald",
                        through="achievements.Achieved",
                        to="members.Person",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="achieved",
            name="achievement",
            field=models.ForeignKey(
                help_text="the achievement that has been achieved",
                on_delete=django.db.models.deletion.CASCADE,
                to="achievements.achievement",
            ),
        ),
        migrations.AddField(
            model_name="achieved",
            name="person",
            field=models.ForeignKey(
                help_text="the person that has achieved",
                on_delete=django.db.models.deletion.CASCADE,
                to="members.person",
            ),
        ),
        migrations.AddConstraint(
            model_name="received",
            constraint=models.UniqueConstraint(
                fields=("person", "medal"), name="one_medal_pp"
            ),
        ),
        migrations.AddConstraint(
            model_name="achieved",
            constraint=models.UniqueConstraint(
                fields=("person", "achievement"), name="unique_achievement"
            ),
        ),
    ]
